/*****************************************************************************
kernel_cfg.c :
  ITRON TvvO
  Copyright(C) 2002 XؖF

VXe\zp`(STEP3)

Windows̃V~[Vœ삷AvP[VvÕRpCɂ͈ȉ̃}N`Kv
	_CMTOY
	_APP_EXPORT
*****************************************************************************/

#include "hal.h"

#include "itron.h"
#include "kernel_id.h"
#include "kernel_cfg.h"

/*****************************************************************************/
/*[U^XNA݃nhA[` ֐vg^Cv錾*/
/*****************************************************************************/
#include "system_def.h"


/*****************************************************************************
ÓIIuWFNg`e[u
*****************************************************************************/

/*ÓI^XN`*/
TASK_DEF TaskDefinitionTable[] = {
	CRE_TSK(IDLE_TASK_ID,	(TA_HLNG | TA_ACT),NULL,NULL,		TMAX_TPRI,	0,NULL, "idle")	/*idle task*/
	CRE_TSK(TID_Init,		(TA_HLNG | TA_ACT),NULL,InitTask,	TPRI_Init,	0,NULL, "init")	/**/
	CRE_TSK(TID_Debug,		(TA_HLNG | TA_ACT),NULL,DebugTask,	TID_Debug,	0,NULL, "debug")	/**/
	CRE_TSK(TID_Timer,		(TA_HLNG | TA_ACT),NULL,TimerTask,	TPRI_Timer,	0,NULL, "timer")	/**/
	CRE_TSK(TID_Led,		(TA_HLNG | TA_ACT),NULL,LedTask,	TPRI_Led,	0,NULL, "led")	/**/
	CRE_TSK(ID_NULL,	(TA_NULL), NULL, NULL, 0, 0, NULL, "")	/*`I*/
};
#define NUM_OF_DEFINED_TASKS	sizeof(TaskDefinitionTable)/sizeof(TASK_DEF)
int	EntriesOfTaskDefinitionTable = NUM_OF_DEFINED_TASKS;

/*ÓIZ}tH`*/
SEMAPHORE_DEF SemaphoreDefinitionTable[] = {
	CRE_SEM(ID_NULL,0,0,0,"")	/*`I*/
};
#define NUM_OF_DEFINED_SEMAPHORES	sizeof(SemaphoreDefinitionTable)/sizeof(SEMAPHORE_DEF)
int	EntriesOfSemaphoreDefinitionTable = NUM_OF_DEFINED_SEMAPHORES;

/*ÓICxgtO`*/
EVENTFLAG_DEF EventflagDefinitionTable[] = {
	CRE_FLG(ID_NULL,0,0,"")	/*`I*/
};
#define NUM_OF_DEFINED_EVENTFLAGS	sizeof(EventflagDefinitionTable)/sizeof(EVENTFLAG_DEF)
int	EntriesOfEventflagDefinitionTable = NUM_OF_DEFINED_EVENTFLAGS;

/*ÓIf[^L[`*/
DATAQUEUE_DEF DataQueueDefinitionTable[] = {
	CRE_DTQ(ID_NULL,0,16,NULL,"")	/*`I*/
};
#define NUM_OF_DEFINED_DATAQUEUES	sizeof(DataQueueDefinitionTable)/sizeof(DATAQUEUE_DEF)
int	EntriesOfDataQueueDefinitionTable = NUM_OF_DEFINED_DATAQUEUES;

/*ÓIC{bNX`*/
MAILBOX_DEF MailboxDefinitionTable[] = {
	CRE_MBX(MID_Led		,(TA_TFIFO | TA_MFIFO)	,1	,NULL, "mbx_led")
	CRE_MBX(ID_NULL, 0, 1, NULL, "")	/*`I*/
};
#define NUM_OF_DEFINED_MAILBOXES	sizeof(MailboxDefinitionTable)/sizeof(MAILBOX_DEF)
int	EntriesOfMailboxDefinitionTable = NUM_OF_DEFINED_MAILBOXES;

/*ÓIŒ蒷[v[`*/
MPF_DEF FixedMemoryPoolDefinitionTable[] = {
//	CRE_MPF(MPXID_Event	,(TA_TFIFO | TA_TPRI) ,8	,32 ,NULL, "mpf_event")
	CRE_MPF(ID_NULL, 0, 0, 0, NULL, "")	/*`I*/
};
#define NUM_OF_DEFINED_MPFS		sizeof(FixedMemoryPoolDefinitionTable)/sizeof(MPF_DEF)
int	EntriesOfFixedMemoryPoolDefinitionTable = NUM_OF_DEFINED_MPFS;

/*ÓInh`*/
CYCHDR_DEF CyclicHnadlerDefinitionTable[] = {
	CRE_CYC(ID_NULL,0,NULL,NULL,1000,10,"")	/*`I*/
};
#define NUM_OF_DEFINED_CYCHDRS	sizeof(CyclicHnadlerDefinitionTable)/sizeof(CYCHDR_DEF)
int	EntriesOfCyclicHnadlerDefinitionTable = NUM_OF_DEFINED_CYCHDRS;

#if 0
/*ÓIA[nh`*/
ALMHDR_DEF AlarmHnadlerDefinitionTable[] = {
	DEF_ALM(ID_NULL,0,100000)	/*`I*/
};
#define NUM_OF_DEFINED_ALMHDRS	sizeof(AlarmHnadlerDefinitionTable)/sizeof(ALMHDR_DEF)
int	EntriesOfAlarmHnadlerDefinitionTable = NUM_OF_DEFINED_ALMHDRS;
#endif

/*ÓI荞݃nh`*/
INTHDR_DEF InterruptHandlerDefinitionTable[] = {
	DEF_INH(INTNO_NULL, 0, NULL, "")	/*`I*/
};
#define NUM_OF_DEFINED_INTHDRS	sizeof(InterruptHandlerDefinitionTable)/sizeof(INTHDR_DEF)
int	EntriesOfInterruptHandlerDefinitionTable = NUM_OF_DEFINED_INTHDRS;


/*ÓI[``*/
INIRTN_DEF InitialRoutineDefinitionTable[] = {
	ATT_INI(TA_NULL,NULL,NULL)		/*`*/
};
#define NUM_OF_DEFINED_INIRTNS	sizeof(InitialRoutineDefinitionTable)/sizeof(INIRTN_DEF)
int	EntriesOfInitialRoutineDefinitionTable = NUM_OF_DEFINED_INIRTNS;


#ifdef _CMTOY
/*****************************************************************************
RtBO[Ve[uJ
*****************************************************************************/
IMPLEMENT_ATTACH_APPLICATION
#endif	/*_CMTOY*/
